﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using Android;
using Android.App;
using Android.Content;
using Android.Content.PM;
using Android.OS;
using Android.Runtime;
using Android.Support.V4.App;
using Android.Support.V4.Content;
using Android.Views;
using Android.Widget;
using ChartToPdfExample.Droid;
using Java.IO;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.XForms.Droid;
using Xamarin.Forms;

[assembly: Dependency(typeof(ExportChartToPdf))]
namespace ChartToPdfExample.Droid
{
    class ExportChartToPdf : IChartDependencyService
    {
        public void SaveAsPDF(Stream chartStream, SfChart chart, PdfDocument document)
        {
            if (ContextCompat.CheckSelfPermission(Android.App.Application.Context, Manifest.Permission.WriteExternalStorage) != Permission.Granted)
            {
                ActivityCompat.RequestPermissions((Android.App.Activity)Forms.Context, new String[] { Manifest.Permission.WriteExternalStorage }, 1);
            }
            if (ContextCompat.CheckSelfPermission(Android.App.Application.Context, Manifest.Permission.ReadExternalStorage) != Permission.Granted)
            {
                ActivityCompat.RequestPermissions((Android.App.Activity)Forms.Context, new String[] { Manifest.Permission.ReadExternalStorage }, 1);
            }
            try
            {
                var page = document.Pages.Add();
                var graphics = page.Graphics;

                graphics.DrawImage(PdfImage.FromStream(chartStream), 0, 0, page.GetClientSize().Width,
                page.GetClientSize().Height);
                MemoryStream stream = new MemoryStream();
                document.Save(stream);
                SavePDF(stream, chart);
            }
            finally
            {
                chartStream.Flush();
                chartStream.Close();
                var nativeChart = SfChartRenderer.GetNativeObject(typeof(SfChart), chart);
                ((Com.Syncfusion.Charts.SfChart)nativeChart).DrawingCacheEnabled = false;
            }
        }
        private void SavePDF(MemoryStream stream, SfChart chart)
        {
            try
            {
                var nativeChart = SfChartRenderer.GetNativeObject(typeof(SfChart), chart);

                ((Com.Syncfusion.Charts.SfChart)nativeChart).DrawingCacheEnabled = false;
            }
            catch (Exception e)
            {
                string msg = e.ToString();
            }
        }
    }
}
